/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the CreateTaskData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateTaskData{}

// CreateTaskData struct for CreateTaskData
type CreateTaskData struct {
	Text *string `json:"text,omitempty"`
	ContextMap map[string]interface{} `json:"context_map,omitempty"`
	Type *string `json:"type,omitempty"`
	// optional
	ChannelId *string `json:"channel_id,omitempty"`
	// only if task should belong to interaction
	InteractionId *string `json:"interaction_id,omitempty"`
	// only if tash should belong to user
	UserId *string `json:"user_id,omitempty"`
	Title *string `json:"title,omitempty"`
	Blocker *bool `json:"blocker,omitempty"`
	ScheduleType *string `json:"schedule_type,omitempty"`
	Interval *string `json:"interval,omitempty"`
	DestinationLink *string `json:"destination_link,omitempty"`
	Deadline *string `json:"deadline,omitempty"`
	Action *string `json:"action,omitempty"`
	Usages []string `json:"usages,omitempty"`
	Element *CreateTaskDataElement `json:"element,omitempty"`
	ScriptId *string `json:"script_id,omitempty"`
	Sendout *CreateTaskDataSendout `json:"sendout,omitempty"`
}

// NewCreateTaskData instantiates a new CreateTaskData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateTaskData() *CreateTaskData {
	this := CreateTaskData{}
	return &this
}

// NewCreateTaskDataWithDefaults instantiates a new CreateTaskData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateTaskDataWithDefaults() *CreateTaskData {
	this := CreateTaskData{}
	return &this
}

// GetText returns the Text field value if set, zero value otherwise.
func (o *CreateTaskData) GetText() string {
	if o == nil || IsNil(o.Text) {
		var ret string
		return ret
	}
	return *o.Text
}

// GetTextOk returns a tuple with the Text field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskData) GetTextOk() (*string, bool) {
	if o == nil || IsNil(o.Text) {
		return nil, false
	}
	return o.Text, true
}

// HasText returns a boolean if a field has been set.
func (o *CreateTaskData) HasText() bool {
	if o != nil && !IsNil(o.Text) {
		return true
	}

	return false
}

// SetText gets a reference to the given string and assigns it to the Text field.
func (o *CreateTaskData) SetText(v string) {
	o.Text = &v
}

// GetContextMap returns the ContextMap field value if set, zero value otherwise.
func (o *CreateTaskData) GetContextMap() map[string]interface{} {
	if o == nil || IsNil(o.ContextMap) {
		var ret map[string]interface{}
		return ret
	}
	return o.ContextMap
}

// GetContextMapOk returns a tuple with the ContextMap field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskData) GetContextMapOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.ContextMap) {
		return map[string]interface{}{}, false
	}
	return o.ContextMap, true
}

// HasContextMap returns a boolean if a field has been set.
func (o *CreateTaskData) HasContextMap() bool {
	if o != nil && !IsNil(o.ContextMap) {
		return true
	}

	return false
}

// SetContextMap gets a reference to the given map[string]interface{} and assigns it to the ContextMap field.
func (o *CreateTaskData) SetContextMap(v map[string]interface{}) {
	o.ContextMap = v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *CreateTaskData) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskData) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *CreateTaskData) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *CreateTaskData) SetType(v string) {
	o.Type = &v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *CreateTaskData) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskData) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *CreateTaskData) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *CreateTaskData) SetChannelId(v string) {
	o.ChannelId = &v
}

// GetInteractionId returns the InteractionId field value if set, zero value otherwise.
func (o *CreateTaskData) GetInteractionId() string {
	if o == nil || IsNil(o.InteractionId) {
		var ret string
		return ret
	}
	return *o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskData) GetInteractionIdOk() (*string, bool) {
	if o == nil || IsNil(o.InteractionId) {
		return nil, false
	}
	return o.InteractionId, true
}

// HasInteractionId returns a boolean if a field has been set.
func (o *CreateTaskData) HasInteractionId() bool {
	if o != nil && !IsNil(o.InteractionId) {
		return true
	}

	return false
}

// SetInteractionId gets a reference to the given string and assigns it to the InteractionId field.
func (o *CreateTaskData) SetInteractionId(v string) {
	o.InteractionId = &v
}

// GetUserId returns the UserId field value if set, zero value otherwise.
func (o *CreateTaskData) GetUserId() string {
	if o == nil || IsNil(o.UserId) {
		var ret string
		return ret
	}
	return *o.UserId
}

// GetUserIdOk returns a tuple with the UserId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskData) GetUserIdOk() (*string, bool) {
	if o == nil || IsNil(o.UserId) {
		return nil, false
	}
	return o.UserId, true
}

// HasUserId returns a boolean if a field has been set.
func (o *CreateTaskData) HasUserId() bool {
	if o != nil && !IsNil(o.UserId) {
		return true
	}

	return false
}

// SetUserId gets a reference to the given string and assigns it to the UserId field.
func (o *CreateTaskData) SetUserId(v string) {
	o.UserId = &v
}

// GetTitle returns the Title field value if set, zero value otherwise.
func (o *CreateTaskData) GetTitle() string {
	if o == nil || IsNil(o.Title) {
		var ret string
		return ret
	}
	return *o.Title
}

// GetTitleOk returns a tuple with the Title field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskData) GetTitleOk() (*string, bool) {
	if o == nil || IsNil(o.Title) {
		return nil, false
	}
	return o.Title, true
}

// HasTitle returns a boolean if a field has been set.
func (o *CreateTaskData) HasTitle() bool {
	if o != nil && !IsNil(o.Title) {
		return true
	}

	return false
}

// SetTitle gets a reference to the given string and assigns it to the Title field.
func (o *CreateTaskData) SetTitle(v string) {
	o.Title = &v
}

// GetBlocker returns the Blocker field value if set, zero value otherwise.
func (o *CreateTaskData) GetBlocker() bool {
	if o == nil || IsNil(o.Blocker) {
		var ret bool
		return ret
	}
	return *o.Blocker
}

// GetBlockerOk returns a tuple with the Blocker field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskData) GetBlockerOk() (*bool, bool) {
	if o == nil || IsNil(o.Blocker) {
		return nil, false
	}
	return o.Blocker, true
}

// HasBlocker returns a boolean if a field has been set.
func (o *CreateTaskData) HasBlocker() bool {
	if o != nil && !IsNil(o.Blocker) {
		return true
	}

	return false
}

// SetBlocker gets a reference to the given bool and assigns it to the Blocker field.
func (o *CreateTaskData) SetBlocker(v bool) {
	o.Blocker = &v
}

// GetScheduleType returns the ScheduleType field value if set, zero value otherwise.
func (o *CreateTaskData) GetScheduleType() string {
	if o == nil || IsNil(o.ScheduleType) {
		var ret string
		return ret
	}
	return *o.ScheduleType
}

// GetScheduleTypeOk returns a tuple with the ScheduleType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskData) GetScheduleTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ScheduleType) {
		return nil, false
	}
	return o.ScheduleType, true
}

// HasScheduleType returns a boolean if a field has been set.
func (o *CreateTaskData) HasScheduleType() bool {
	if o != nil && !IsNil(o.ScheduleType) {
		return true
	}

	return false
}

// SetScheduleType gets a reference to the given string and assigns it to the ScheduleType field.
func (o *CreateTaskData) SetScheduleType(v string) {
	o.ScheduleType = &v
}

// GetInterval returns the Interval field value if set, zero value otherwise.
func (o *CreateTaskData) GetInterval() string {
	if o == nil || IsNil(o.Interval) {
		var ret string
		return ret
	}
	return *o.Interval
}

// GetIntervalOk returns a tuple with the Interval field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskData) GetIntervalOk() (*string, bool) {
	if o == nil || IsNil(o.Interval) {
		return nil, false
	}
	return o.Interval, true
}

// HasInterval returns a boolean if a field has been set.
func (o *CreateTaskData) HasInterval() bool {
	if o != nil && !IsNil(o.Interval) {
		return true
	}

	return false
}

// SetInterval gets a reference to the given string and assigns it to the Interval field.
func (o *CreateTaskData) SetInterval(v string) {
	o.Interval = &v
}

// GetDestinationLink returns the DestinationLink field value if set, zero value otherwise.
func (o *CreateTaskData) GetDestinationLink() string {
	if o == nil || IsNil(o.DestinationLink) {
		var ret string
		return ret
	}
	return *o.DestinationLink
}

// GetDestinationLinkOk returns a tuple with the DestinationLink field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskData) GetDestinationLinkOk() (*string, bool) {
	if o == nil || IsNil(o.DestinationLink) {
		return nil, false
	}
	return o.DestinationLink, true
}

// HasDestinationLink returns a boolean if a field has been set.
func (o *CreateTaskData) HasDestinationLink() bool {
	if o != nil && !IsNil(o.DestinationLink) {
		return true
	}

	return false
}

// SetDestinationLink gets a reference to the given string and assigns it to the DestinationLink field.
func (o *CreateTaskData) SetDestinationLink(v string) {
	o.DestinationLink = &v
}

// GetDeadline returns the Deadline field value if set, zero value otherwise.
func (o *CreateTaskData) GetDeadline() string {
	if o == nil || IsNil(o.Deadline) {
		var ret string
		return ret
	}
	return *o.Deadline
}

// GetDeadlineOk returns a tuple with the Deadline field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskData) GetDeadlineOk() (*string, bool) {
	if o == nil || IsNil(o.Deadline) {
		return nil, false
	}
	return o.Deadline, true
}

// HasDeadline returns a boolean if a field has been set.
func (o *CreateTaskData) HasDeadline() bool {
	if o != nil && !IsNil(o.Deadline) {
		return true
	}

	return false
}

// SetDeadline gets a reference to the given string and assigns it to the Deadline field.
func (o *CreateTaskData) SetDeadline(v string) {
	o.Deadline = &v
}

// GetAction returns the Action field value if set, zero value otherwise.
func (o *CreateTaskData) GetAction() string {
	if o == nil || IsNil(o.Action) {
		var ret string
		return ret
	}
	return *o.Action
}

// GetActionOk returns a tuple with the Action field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskData) GetActionOk() (*string, bool) {
	if o == nil || IsNil(o.Action) {
		return nil, false
	}
	return o.Action, true
}

// HasAction returns a boolean if a field has been set.
func (o *CreateTaskData) HasAction() bool {
	if o != nil && !IsNil(o.Action) {
		return true
	}

	return false
}

// SetAction gets a reference to the given string and assigns it to the Action field.
func (o *CreateTaskData) SetAction(v string) {
	o.Action = &v
}

// GetUsages returns the Usages field value if set, zero value otherwise.
func (o *CreateTaskData) GetUsages() []string {
	if o == nil || IsNil(o.Usages) {
		var ret []string
		return ret
	}
	return o.Usages
}

// GetUsagesOk returns a tuple with the Usages field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskData) GetUsagesOk() ([]string, bool) {
	if o == nil || IsNil(o.Usages) {
		return nil, false
	}
	return o.Usages, true
}

// HasUsages returns a boolean if a field has been set.
func (o *CreateTaskData) HasUsages() bool {
	if o != nil && !IsNil(o.Usages) {
		return true
	}

	return false
}

// SetUsages gets a reference to the given []string and assigns it to the Usages field.
func (o *CreateTaskData) SetUsages(v []string) {
	o.Usages = v
}

// GetElement returns the Element field value if set, zero value otherwise.
func (o *CreateTaskData) GetElement() CreateTaskDataElement {
	if o == nil || IsNil(o.Element) {
		var ret CreateTaskDataElement
		return ret
	}
	return *o.Element
}

// GetElementOk returns a tuple with the Element field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskData) GetElementOk() (*CreateTaskDataElement, bool) {
	if o == nil || IsNil(o.Element) {
		return nil, false
	}
	return o.Element, true
}

// HasElement returns a boolean if a field has been set.
func (o *CreateTaskData) HasElement() bool {
	if o != nil && !IsNil(o.Element) {
		return true
	}

	return false
}

// SetElement gets a reference to the given CreateTaskDataElement and assigns it to the Element field.
func (o *CreateTaskData) SetElement(v CreateTaskDataElement) {
	o.Element = &v
}

// GetScriptId returns the ScriptId field value if set, zero value otherwise.
func (o *CreateTaskData) GetScriptId() string {
	if o == nil || IsNil(o.ScriptId) {
		var ret string
		return ret
	}
	return *o.ScriptId
}

// GetScriptIdOk returns a tuple with the ScriptId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskData) GetScriptIdOk() (*string, bool) {
	if o == nil || IsNil(o.ScriptId) {
		return nil, false
	}
	return o.ScriptId, true
}

// HasScriptId returns a boolean if a field has been set.
func (o *CreateTaskData) HasScriptId() bool {
	if o != nil && !IsNil(o.ScriptId) {
		return true
	}

	return false
}

// SetScriptId gets a reference to the given string and assigns it to the ScriptId field.
func (o *CreateTaskData) SetScriptId(v string) {
	o.ScriptId = &v
}

// GetSendout returns the Sendout field value if set, zero value otherwise.
func (o *CreateTaskData) GetSendout() CreateTaskDataSendout {
	if o == nil || IsNil(o.Sendout) {
		var ret CreateTaskDataSendout
		return ret
	}
	return *o.Sendout
}

// GetSendoutOk returns a tuple with the Sendout field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateTaskData) GetSendoutOk() (*CreateTaskDataSendout, bool) {
	if o == nil || IsNil(o.Sendout) {
		return nil, false
	}
	return o.Sendout, true
}

// HasSendout returns a boolean if a field has been set.
func (o *CreateTaskData) HasSendout() bool {
	if o != nil && !IsNil(o.Sendout) {
		return true
	}

	return false
}

// SetSendout gets a reference to the given CreateTaskDataSendout and assigns it to the Sendout field.
func (o *CreateTaskData) SetSendout(v CreateTaskDataSendout) {
	o.Sendout = &v
}

func (o CreateTaskData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateTaskData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Text) {
		toSerialize["text"] = o.Text
	}
	if !IsNil(o.ContextMap) {
		toSerialize["context_map"] = o.ContextMap
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	if !IsNil(o.InteractionId) {
		toSerialize["interaction_id"] = o.InteractionId
	}
	if !IsNil(o.UserId) {
		toSerialize["user_id"] = o.UserId
	}
	if !IsNil(o.Title) {
		toSerialize["title"] = o.Title
	}
	if !IsNil(o.Blocker) {
		toSerialize["blocker"] = o.Blocker
	}
	if !IsNil(o.ScheduleType) {
		toSerialize["schedule_type"] = o.ScheduleType
	}
	if !IsNil(o.Interval) {
		toSerialize["interval"] = o.Interval
	}
	if !IsNil(o.DestinationLink) {
		toSerialize["destination_link"] = o.DestinationLink
	}
	if !IsNil(o.Deadline) {
		toSerialize["deadline"] = o.Deadline
	}
	if !IsNil(o.Action) {
		toSerialize["action"] = o.Action
	}
	if !IsNil(o.Usages) {
		toSerialize["usages"] = o.Usages
	}
	if !IsNil(o.Element) {
		toSerialize["element"] = o.Element
	}
	if !IsNil(o.ScriptId) {
		toSerialize["script_id"] = o.ScriptId
	}
	if !IsNil(o.Sendout) {
		toSerialize["sendout"] = o.Sendout
	}
	return toSerialize, nil
}

type NullableCreateTaskData struct {
	value *CreateTaskData
	isSet bool
}

func (v NullableCreateTaskData) Get() *CreateTaskData {
	return v.value
}

func (v *NullableCreateTaskData) Set(val *CreateTaskData) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateTaskData) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateTaskData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateTaskData(val *CreateTaskData) *NullableCreateTaskData {
	return &NullableCreateTaskData{value: val, isSet: true}
}

func (v NullableCreateTaskData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateTaskData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


